"use strict";

{
	C3.Plugins.Rex_TweenTasks.Acts =
	{
		ApplyEasing(paramName, easeType)
		{
			if (!this.exp_fnParams.hasOwnProperty(paramName))
				return;

			var param = this.exp_fnParams[paramName];
			easeParam(param, this.exp_fnPercentage, easeType);
		},
		NewTweenTask(taskName, fnName, interval, repeatCount)
		{
			this.tasksMgr.CreateTweenTask(taskName, fnName, interval, repeatCount);
		},
		SetFnParameter(taskName, paramName, start, end, easeType)
		{
			var task = this.tasksMgr.GetTask(taskName);
			if ((!task) || (!task.SetFnParameter))
				return;

			task.SetFnParameter(paramName, start, end, easeType);
		},
		NewWaitTask(taskName, interval)
		{
			this.tasksMgr.CreateWaitTask(taskName, interval);
		},
		NewSequenceTask(taskName, repeatCount, childrenTasks)
		{
			var task = this.tasksMgr.CreateSequenceTask(taskName, repeatCount);
			var i, cnt = childrenTasks.length,
				childTask;
			for (i = 0; i < cnt; i++) {
				this.tasksMgr.AddChildTask(taskName, childrenTasks[i]);
			}
		},
		NewParallelTask(taskName, repeatCount, childrenTasks)
		{
			var task = this.tasksMgr.CreateParallelTask(taskName, repeatCount);
			var i, cnt = childrenTasks.length,
				childTask;
			for (i = 0; i < cnt; i++) {
				this.tasksMgr.AddChildTask(taskName, childrenTasks[i]);
			}
		},
		NewInversedTweenTask(taskName, targetTaskName)
		{
			this.tasksMgr.CreateInversedTask(taskName, targetTaskName);
		},
		NewWaitForSignalTask(taskName, signalName)
		{
			this.tasksMgr.CreateWaitForSignalTask(taskName, signalName);
		},
		AddChildTask(parentTaskName, childTaskName)
		{
			this.tasksMgr.AddChildTask(parentTaskName, childTaskName);
		},
		SetTaskParameter(taskName, paramName, paramValue)
		{
			this.tasksMgr.SetTaskParameter(taskName, paramName, paramValue);
		},
		BindInst(taskName, objtype, destroyAfterTaskDone)
		{
			if (objtype == null)
				return;

			var inst, sid;
			if (typeof (objtype) == "object") {
				inst = objtype.GetFirstPicked();
			} else {
				var uid = objtype;
				inst = this._runtime.GetInstanceByUID(uid);
				objtype = inst.type;
			}

			if (!inst)
				return;

			var task = this.tasksMgr.GetCandidateTask(taskName);
			if (task)
				task.BindInst(inst.GetUID(), objtype.sid, (destroyAfterTaskDone == 1));
		},
		StartTask(taskName, destroyAfterDone)
		{
			this.tasksMgr.StartTask(taskName, destroyAfterDone);
		},
		PauseTask(taskName)
		{
			this.tasksMgr.PauseTask(taskName);
		},
		ResumeTask(taskName)
		{
			this.tasksMgr.ResumeTask(taskName);
		},
		DestroyTask(taskName)
		{
			this.tasksMgr.DestroyTask(taskName);
		},
		ContinueTask(taskName, signalName)
		{
			this.tasksMgr.ContinueTasks(taskName, signalName);
		},
		ContinueTasksBySignal(signalName)
		{
			this.tasksMgr.ContinueTasks(null, signalName);
		},
		SetRemainIntervalPercentage(taskName, remainIntervalPercentage)
		{
			var task = this.tasksMgr.GetActivatedTask(taskName);
			if (task == null)
				return;

			if ((task.interval == null) || (task.remainInterval == null))
				return;

			task.remainInterval = task.interval * remainIntervalPercentage;
		}
	};
}
